//
// Display and keyboard functionality
// (c) 3.10.2016 Ingo D. Rullhusen
//

#ifndef DISKEY_H
#define DISKEY_H

#include "timer.h"
#include "tuner.h"


extern uint8_t SEGMENT[6];
extern volatile uint8_t key_matrix[6];


#define K_0_MW 0
#define K_1 1
#define K_2 2
#define K_3 3
#define K_4 4
#define K_5 5
#define K_6 6
#define K_7 7
#define K_8 8
#define K_9_FM 9
#define K_STORE 10
#define K_LEFT  11
#define K_RIGHT 12
#define K_PWROFF 13
#define K_RESET 14
#define K_NONE 255
extern volatile uint8_t KEY;


#define M_ON     0
#define M_OFF    1
#define M_TSET   2
#define M_CANCEL 3
#define M_CHECK  4
#define M_CSET   5
#define M_BATPWR 6
#define M_RESET  7
#define M_MSG    8
#define M_Error  0xff
extern volatile uint8_t MODE;


extern volatile uint8_t AUTOSCAN;


#define PLL_TUNED 0
#define PLL_SET   1
extern volatile uint8_t diskey_set_pll;
extern uint8_t tuneFreqR[8]; // PPL register 1 to 8


void diskey_init(void);


void diskey_pLED( uint8_t led );
void diskey_sLED( uint8_t led );

uint8_t diskey_hex2seg( uint8_t c );
void diskey_time2seg( bcd_time *clk );

void diskey_fm2seg( freq10k_fm );
void diskey_am2seg( freq1k_am );

void diskey_str2seg( const char *PSTRs, const uint8_t p2, const uint8_t p3 );


#endif
